Index: /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 8691)
+++ /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 8692)
@@ -534,23 +534,10 @@
         RunCollection runs = new RunCollection();
 
-        foreach (HiveTask subTask in job.HiveTasks) {
-          GetAllRunsFromHiveTask(runs, subTask);
+        foreach (HiveTask hiveTask in job.HiveTasks) {
+          TaskUtil.GetAllRunsFromHiveTask(runs, hiveTask);
         }
         return runs;
       } else {
         return null;
-      }
-    }
-
-    private void GetAllRunsFromHiveTask(RunCollection runs, HiveTask task) {
-      foreach (HiveTask subTask in task.ChildHiveTasks) {
-        GetAllRunsFromHiveTask(runs, subTask);
-      }
-
-      if (task.ChildHiveTasks.Count == 0) {
-        if (task is OptimizerHiveTask) {
-          OptimizerHiveTask ohTask = task as OptimizerHiveTask;
-          runs.AddRange(ohTask.ItemTask.Item.Runs);
-        }
       }
     }
Index: /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs	(revision 8691)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs	(revision 8692)
@@ -25,4 +25,5 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Optimization;
 using HeuristicLab.PluginInfrastructure;
 
@@ -53,5 +54,7 @@
     protected override void Job_ItemChanged(object sender, EventArgs e) {
       if (Content != null && Content.Task != null && Content.ItemTask.Item != null) {
-        runCollectionViewHost.Content = Content.ItemTask.Item.Runs;
+        RunCollection runs = new RunCollection();
+        TaskUtil.GetAllRunsFromHiveTask(runs, Content);
+        runCollectionViewHost.Content = runs;
       } else {
         runCollectionViewHost.Content = null;
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 8691)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 8692)
@@ -130,4 +130,5 @@
     <Compile Include="StateLogList.cs" />
     <Compile Include="StateLogListList.cs" />
+    <Compile Include="Util\TaskUtil.cs" />
     <None Include="app.config">
       <SubType>Designer</SubType>
@@ -249,10 +250,10 @@
   </PropertyGroup>
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
 set Outdir=$(Outdir)
 call PreBuildEvent.cmd</PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/Util/TaskUtil.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/Util/TaskUtil.cs	(revision 8692)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/Util/TaskUtil.cs	(revision 8692)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Clients.Hive {
+  public static class TaskUtil {
+    public static void GetAllRunsFromHiveTask(RunCollection runs, HiveTask task) {
+      foreach (HiveTask childTask in task.ChildHiveTasks) {
+        GetAllRunsFromHiveTask(runs, childTask);
+      }
+
+      if (task.ChildHiveTasks.Count == 0) {
+        if (task is OptimizerHiveTask) {
+          OptimizerHiveTask ohTask = task as OptimizerHiveTask;
+          runs.AddRange(ohTask.ItemTask.Item.Runs);
+        }
+      }
+    }
+  }
+}