Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.Designer.cs	(revision 8692)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.Designer.cs	(revision 8693)
@@ -24,29 +24,34 @@
     /// </summary>
     private void InitializeComponent() {
-      this.ShuffelDataCheckbox = new System.Windows.Forms.CheckBox();
+      this.ShuffleDataCheckbox = new System.Windows.Forms.CheckBox();
       this.OkButton = new System.Windows.Forms.Button();
-      this.CancelButton = new System.Windows.Forms.Button();
       this.TrainingTestTrackBar = new System.Windows.Forms.TrackBar();
       this.TrainingTestGroupBox = new System.Windows.Forms.GroupBox();
       this.TestLabel = new System.Windows.Forms.Label();
       this.TrainingLabel = new System.Windows.Forms.Label();
+      this.CancelButton = new System.Windows.Forms.Button();
+      this.openFileButton = new System.Windows.Forms.Button();
+      this.ProblemFileLabel = new System.Windows.Forms.Label();
+      this.ProblemTextBox = new System.Windows.Forms.TextBox();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
       ((System.ComponentModel.ISupportInitialize)(this.TrainingTestTrackBar)).BeginInit();
       this.TrainingTestGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
-      // ShuffelDataCheckbox
+      // ShuffleDataCheckbox
       // 
-      this.ShuffelDataCheckbox.AutoSize = true;
-      this.ShuffelDataCheckbox.Location = new System.Drawing.Point(18, 12);
-      this.ShuffelDataCheckbox.Name = "ShuffelDataCheckbox";
-      this.ShuffelDataCheckbox.Size = new System.Drawing.Size(91, 17);
-      this.ShuffelDataCheckbox.TabIndex = 1;
-      this.ShuffelDataCheckbox.Text = "Shuffel Data?";
-      this.ShuffelDataCheckbox.UseVisualStyleBackColor = true;
+      this.ShuffleDataCheckbox.AutoSize = true;
+      this.ShuffleDataCheckbox.Location = new System.Drawing.Point(12, 38);
+      this.ShuffleDataCheckbox.Name = "ShuffleDataCheckbox";
+      this.ShuffleDataCheckbox.Size = new System.Drawing.Size(91, 17);
+      this.ShuffleDataCheckbox.TabIndex = 1;
+      this.ShuffleDataCheckbox.Text = "Shuffle Data?";
+      this.ShuffleDataCheckbox.UseVisualStyleBackColor = true;
       // 
       // OkButton
       // 
       this.OkButton.DialogResult = System.Windows.Forms.DialogResult.OK;
-      this.OkButton.Location = new System.Drawing.Point(18, 121);
+      this.OkButton.Enabled = false;
+      this.OkButton.Location = new System.Drawing.Point(61, 147);
       this.OkButton.Name = "OkButton";
       this.OkButton.Size = new System.Drawing.Size(75, 23);
@@ -55,21 +60,13 @@
       this.OkButton.UseVisualStyleBackColor = true;
       // 
-      // CancelButton
-      // 
-      this.CancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
-      this.CancelButton.Location = new System.Drawing.Point(142, 121);
-      this.CancelButton.Name = "CancelButton";
-      this.CancelButton.Size = new System.Drawing.Size(75, 23);
-      this.CancelButton.TabIndex = 3;
-      this.CancelButton.Text = "&Cancel";
-      this.CancelButton.UseVisualStyleBackColor = true;
-      // 
       // TrainingTestTrackBar
       // 
+      this.TrainingTestTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.TrainingTestTrackBar.Location = new System.Drawing.Point(6, 19);
       this.TrainingTestTrackBar.Maximum = 100;
       this.TrainingTestTrackBar.Minimum = 1;
       this.TrainingTestTrackBar.Name = "TrainingTestTrackBar";
-      this.TrainingTestTrackBar.Size = new System.Drawing.Size(210, 45);
+      this.TrainingTestTrackBar.Size = new System.Drawing.Size(303, 45);
       this.TrainingTestTrackBar.TabIndex = 4;
       this.TrainingTestTrackBar.TickStyle = System.Windows.Forms.TickStyle.None;
@@ -82,7 +79,7 @@
       this.TrainingTestGroupBox.Controls.Add(this.TrainingLabel);
       this.TrainingTestGroupBox.Controls.Add(this.TrainingTestTrackBar);
-      this.TrainingTestGroupBox.Location = new System.Drawing.Point(4, 35);
+      this.TrainingTestGroupBox.Location = new System.Drawing.Point(12, 61);
       this.TrainingTestGroupBox.Name = "TrainingTestGroupBox";
-      this.TrainingTestGroupBox.Size = new System.Drawing.Size(222, 80);
+      this.TrainingTestGroupBox.Size = new System.Drawing.Size(315, 80);
       this.TrainingTestGroupBox.TabIndex = 5;
       this.TrainingTestGroupBox.TabStop = false;
@@ -92,5 +89,5 @@
       // 
       this.TestLabel.AutoSize = true;
-      this.TestLabel.Location = new System.Drawing.Point(108, 51);
+      this.TestLabel.Location = new System.Drawing.Point(188, 51);
       this.TestLabel.Name = "TestLabel";
       this.TestLabel.Size = new System.Drawing.Size(57, 13);
@@ -101,5 +98,5 @@
       // 
       this.TrainingLabel.AutoSize = true;
-      this.TrainingLabel.Location = new System.Drawing.Point(11, 51);
+      this.TrainingLabel.Location = new System.Drawing.Point(50, 51);
       this.TrainingLabel.Name = "TrainingLabel";
       this.TrainingLabel.Size = new System.Drawing.Size(74, 13);
@@ -107,17 +104,65 @@
       this.TrainingLabel.Text = "Training: 66 %";
       // 
+      // CancelButton
+      // 
+      this.CancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
+      this.CancelButton.Location = new System.Drawing.Point(182, 147);
+      this.CancelButton.Name = "CancelButton";
+      this.CancelButton.Size = new System.Drawing.Size(75, 23);
+      this.CancelButton.TabIndex = 3;
+      this.CancelButton.Text = "&Cancel";
+      this.CancelButton.UseVisualStyleBackColor = true;
+      // 
+      // openFileButton
+      // 
+      this.openFileButton.Location = new System.Drawing.Point(303, 12);
+      this.openFileButton.Name = "openFileButton";
+      this.openFileButton.Size = new System.Drawing.Size(24, 24);
+      this.openFileButton.TabIndex = 8;
+      this.openFileButton.UseVisualStyleBackColor = true;
+      this.openFileButton.Click += new System.EventHandler(this.openFileButton_Click);
+      // 
+      // ProblemFileLabel
+      // 
+      this.ProblemFileLabel.AutoSize = true;
+      this.ProblemFileLabel.Location = new System.Drawing.Point(12, 15);
+      this.ProblemFileLabel.Name = "ProblemFileLabel";
+      this.ProblemFileLabel.Size = new System.Drawing.Size(67, 13);
+      this.ProblemFileLabel.TabIndex = 6;
+      this.ProblemFileLabel.Text = "Problem File:";
+      // 
+      // ProblemTextBox
+      // 
+      this.ProblemTextBox.Location = new System.Drawing.Point(85, 12);
+      this.ProblemTextBox.Name = "ProblemTextBox";
+      this.ProblemTextBox.ReadOnly = true;
+      this.ProblemTextBox.Size = new System.Drawing.Size(212, 20);
+      this.ProblemTextBox.TabIndex = 9;
+      // 
+      // openFileDialog
+      // 
+      this.openFileDialog.Filter = "CSV files (*.csv)|*.csv|Text files (*.txt)|*.txt|All files (*.*)|*.*";
+      // 
       // DataAnalysisImportTypeDialog
       // 
+      this.AcceptButton = this.OkButton;
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(229, 151);
+      this.ClientSize = new System.Drawing.Size(339, 179);
+      this.ControlBox = false;
+      this.Controls.Add(this.ProblemTextBox);
+      this.Controls.Add(this.openFileButton);
+      this.Controls.Add(this.ProblemFileLabel);
       this.Controls.Add(this.CancelButton);
       this.Controls.Add(this.OkButton);
-      this.Controls.Add(this.ShuffelDataCheckbox);
+      this.Controls.Add(this.ShuffleDataCheckbox);
       this.Controls.Add(this.TrainingTestGroupBox);
       this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
+      this.MaximizeBox = false;
+      this.MinimizeBox = false;
       this.Name = "DataAnalysisImportTypeDialog";
+      this.ShowIcon = false;
       this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
-      this.Text = "DataAnalysisImportTypeDialog";
+      this.Text = "CSV Import";
       ((System.ComponentModel.ISupportInitialize)(this.TrainingTestTrackBar)).EndInit();
       this.TrainingTestGroupBox.ResumeLayout(false);
@@ -130,11 +175,15 @@
     #endregion
 
-    protected System.Windows.Forms.CheckBox ShuffelDataCheckbox;
+    protected System.Windows.Forms.CheckBox ShuffleDataCheckbox;
     protected System.Windows.Forms.Button OkButton;
+    protected System.Windows.Forms.TrackBar TrainingTestTrackBar;
+    protected System.Windows.Forms.GroupBox TrainingTestGroupBox;
+    protected System.Windows.Forms.Label TestLabel;
+    protected System.Windows.Forms.Label TrainingLabel;
     protected System.Windows.Forms.Button CancelButton;
-    private System.Windows.Forms.TrackBar TrainingTestTrackBar;
-    private System.Windows.Forms.GroupBox TrainingTestGroupBox;
-    private System.Windows.Forms.Label TestLabel;
-    private System.Windows.Forms.Label TrainingLabel;
+    protected System.Windows.Forms.OpenFileDialog openFileDialog;
+    protected System.Windows.Forms.Label ProblemFileLabel;
+    protected System.Windows.Forms.Button openFileButton;
+    protected System.Windows.Forms.TextBox ProblemTextBox;
 
   }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.cs	(revision 8692)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.cs	(revision 8693)
@@ -25,8 +25,12 @@
   public partial class DataAnalysisImportTypeDialog : Form {
 
+    public string Path {
+      get { return ProblemTextBox.Text; }
+    }
+
     public DataAnalysisImportType ImportType {
       get {
         return new DataAnalysisImportType() {
-          Shuffle = ShuffelDataCheckbox.Checked,
+          Shuffle = ShuffleDataCheckbox.Checked,
           Training = TrainingTestTrackBar.Value
         };
@@ -42,4 +46,11 @@
       TestLabel.Text = "Test: " + (TrainingTestTrackBar.Maximum - TrainingTestTrackBar.Value) + " %";
     }
+
+    private void openFileButton_Click(object sender, System.EventArgs e) {
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        ProblemTextBox.Text = openFileDialog.FileName;
+        OkButton.Enabled = true;
+      }
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisInstanceConsumerView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisInstanceConsumerView.cs	(revision 8692)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisInstanceConsumerView.cs	(revision 8693)
@@ -47,14 +47,10 @@
       var provider = SelectedProvider as DataAnalysisInstanceProvider<T>;
       if (provider != null) {
-        openFileDialog.FileName = GetProblemType() + " instance";
-        if (openFileDialog.ShowDialog() == DialogResult.OK) {
+        DataAnalysisImportTypeDialog importTypeDialog = new DataAnalysisImportTypeDialog();
+        if (importTypeDialog.ShowDialog() == DialogResult.OK) {
           T instance = default(T);
           try {
-            DataAnalysisImportTypeDialog importTypeDialog = new DataAnalysisImportTypeDialog();
-            if (importTypeDialog.ShowDialog() == DialogResult.OK) {
-              instance = provider.ImportData(openFileDialog.FileName, importTypeDialog.ImportType);
-            } else {
-              return;
-            }
+            instance = provider.ImportData(importTypeDialog.Path, importTypeDialog.ImportType);
+
           }
           catch (Exception ex) {
@@ -66,6 +62,8 @@
           }
           catch (Exception ex) {
-            MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", Path.GetFileName(openFileDialog.FileName), Environment.NewLine + ex.Message), "Cannot load instance");
+            MessageBox.Show(String.Format("This problem does not support loading the instance {0}: {1}", Path.GetFileName(importTypeDialog.Path), Environment.NewLine + ex.Message), "Cannot load instance");
           }
+        } else {
+          return;
         }
       } else {
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.csproj	(revision 8692)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.csproj	(revision 8693)
@@ -116,5 +116,5 @@
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
-     <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -123,5 +123,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs	(revision 8692)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs	(revision 8693)
@@ -96,4 +96,5 @@
       csvFileParser.Parse(path);
 
+      int trainingPartEnd = (csvFileParser.Rows * type.Training) / 100;
       List<IList> values = csvFileParser.Values;
       if (type.Shuffle) {
@@ -106,5 +107,4 @@
       // turn of input variables that are constant in the training partition
       var allowedInputVars = new List<string>();
-      int trainingPartEnd = (csvFileParser.Rows * type.Training) / 100;
       var trainingIndizes = Enumerable.Range(0, trainingPartEnd);
       foreach (var variableName in dataset.DoubleVariables) {
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8692)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8693)
@@ -98,8 +98,8 @@
   </PropertyGroup>
   <ItemGroup>
-     <Reference Include="ICSharpCode.SharpZipLib">
-		<HintPath>..\..\HeuristicLab.PluginInfrastructure\3.3\ICSharpCode.SharpZipLib.dll</HintPath>
-		<Private>False</Private>
-	</Reference>
+    <Reference Include="ICSharpCode.SharpZipLib">
+      <HintPath>..\..\HeuristicLab.PluginInfrastructure\3.3\ICSharpCode.SharpZipLib.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
@@ -249,5 +249,5 @@
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -255,5 +255,5 @@
 
 call PreBuildEvent.cmd</PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)