Index: /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 8699)
+++ /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 8700)
@@ -534,6 +534,9 @@
         RunCollection runs = new RunCollection();
 
-        foreach (HiveTask hiveTask in job.HiveTasks) {
-          TaskUtil.GetAllRunsFromHiveTask(runs, hiveTask);
+        foreach (HiveTask subTask in job.HiveTasks) {
+          if (subTask is OptimizerHiveTask) {
+            OptimizerHiveTask ohTask = subTask as OptimizerHiveTask;
+            runs.AddRange(ohTask.ItemTask.Item.Runs);
+          }
         }
         return runs;
Index: /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs	(revision 8699)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/OptimizerHiveTaskView.cs	(revision 8700)
@@ -25,5 +25,4 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
-using HeuristicLab.Optimization;
 using HeuristicLab.PluginInfrastructure;
 
@@ -54,7 +53,5 @@
     protected override void Job_ItemChanged(object sender, EventArgs e) {
       if (Content != null && Content.Task != null && Content.ItemTask.Item != null) {
-        RunCollection runs = new RunCollection();
-        TaskUtil.GetAllRunsFromHiveTask(runs, Content);
-        runCollectionViewHost.Content = runs;
+        runCollectionViewHost.Content = Content.ItemTask.Item.Runs;
       } else {
         runCollectionViewHost.Content = null;
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 8699)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 8700)
@@ -130,5 +130,4 @@
     <Compile Include="StateLogList.cs" />
     <Compile Include="StateLogListList.cs" />
-    <Compile Include="Util\TaskUtil.cs" />
     <None Include="app.config">
       <SubType>Designer</SubType>
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 8699)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 8700)
@@ -483,6 +483,6 @@
       foreach (LightweightTask task in childTasks) {
         HiveTask childHiveTask = allHiveTasks[task.Id];
+        BuildHiveJobTree(childHiveTask, allTasks, allHiveTasks);
         parentHiveTask.AddChildHiveTask(childHiveTask);
-        BuildHiveJobTree(childHiveTask, allTasks, allHiveTasks);
       }
     }
Index: unk/sources/HeuristicLab.Clients.Hive/3.3/Util/TaskUtil.cs
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/Util/TaskUtil.cs	(revision 8699)
+++ 	(revision )
@@ -1,39 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Optimization;
-
-namespace HeuristicLab.Clients.Hive {
-  public static class TaskUtil {
-    public static void GetAllRunsFromHiveTask(RunCollection runs, HiveTask task) {
-      foreach (HiveTask childTask in task.ChildHiveTasks) {
-        GetAllRunsFromHiveTask(runs, childTask);
-      }
-
-      if (task.ChildHiveTasks.Count == 0) {
-        if (task is OptimizerHiveTask) {
-          OptimizerHiveTask ohTask = task as OptimizerHiveTask;
-          runs.AddRange(ohTask.ItemTask.Item.Runs);
-        }
-      }
-    }
-  }
-}